/*
 * J[R[hIc[
 * @version 1.0 beta
 */

package frame;
import java.awt.*;
import java.awt.event.*;
import java.lang.Math;

public class ColorSelectCanvas extends Panel
		implements MouseListener,MouseMotionListener{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 3388656504170612829L;
	private float hColor,sColor,bColor;
	private Image offScr;

	private ColorSelectFrame m_target;
	
	private boolean drag_colorarc;
	private boolean drag_colorrect;
	
	private final int SCR_X = 225;
	private final int SCR_Y = 225;
	private final int COLOR_ARC_SIZE = 200;
	private final int COLOR_RECT_SIZE = 100;
	private final int COLOR_H_MAX = 360;	
	private final int COLOR_S_MAX = 100;	
	private final int COLOR_B_MAX = 100;
	
	private final int COLOR_ARC_X = 25;
	private final int COLOR_ARC_Y = 25;
	
	/*
	 * RXgN^
	 */
	public ColorSelectCanvas( ColorSelectFrame target ){
		// }EX֘Ȁ
		drag_colorarc = false;
		drag_colorrect = false;
		addMouseListener(this);
		addMouseMotionListener(this);
		
		// Ct[̃|C^
		m_target = target;
		
		// F֘Ȁ
		hColor = 0;
		sColor = 0;
		bColor = 0;
	}
	
	/*
	 * ItXN[̍XVƕ`
	 * @see java.awt.Container#update(java.awt.Graphics)
	 */
	public void update(Graphics g){
		Graphics offG;
		if(offScr==null){
			offScr = createImage(SCR_X,SCR_Y);
		}
		offG = offScr.getGraphics();
		paint(offG);
		g.drawImage(offScr, 0, 0,this);		
	}
	
	/*
	 * `揈
	 * @see java.awt.Container#paint(java.awt.Graphics)
	 */
	public void paint(Graphics g){
		
		if(offScr==null){
			repaint();
			return;
		}
		
		// 
		g.setColor(Color.LIGHT_GRAY);
		g.fillRect(0,0,SCR_X,SCR_Y);
		
		// F~
		for(int x=0;x<360;x++){
			g.setColor(Color.getHSBColor((float)(x)/COLOR_H_MAX, 1, 1));
			g.fillArc(COLOR_ARC_X, COLOR_ARC_Y, COLOR_ARC_SIZE, COLOR_ARC_SIZE, x, 1);
		}
		// F~ʂ̐؂蔲
		g.setColor(Color.LIGHT_GRAY);
		g.fillOval(25+COLOR_ARC_X, 25+COLOR_ARC_Y, 150, 150);
		// xʓx{bNX
		for(int x=0;x<=COLOR_RECT_SIZE;x++){
			for(int y=0;y<=COLOR_RECT_SIZE;y++){
				float b,s;
				b = x;
				s = 100-y;
				if(s<0) s=0;
				g.setColor(Color.getHSBColor(hColor/COLOR_H_MAX, s/COLOR_S_MAX, b/COLOR_B_MAX));
				g.fillRect(50+x+COLOR_ARC_X, 50+y+COLOR_ARC_Y, 1, 1);
			}
		}
		// xʓx{bNX̃J[\
		g.setColor(Color.getHSBColor(hColor/COLOR_H_MAX, (100-sColor)/COLOR_S_MAX, (100-bColor)/COLOR_B_MAX));
		g.fillRect( (int)(COLOR_ARC_X + bColor -3+50), (int)(COLOR_ARC_Y + (100-sColor) -3+50), 6, 6);
		g.setColor(Color.BLACK);
		g.drawRect( (int)(COLOR_ARC_X + bColor -3+50), (int)(COLOR_ARC_Y + (100-sColor) -3+50), 6, 6);
		// F~ʂ̃J[\
		g.setColor(Color.getHSBColor(hColor/COLOR_H_MAX, (float)0.5, 1));
		g.fillRect( (int)( COLOR_ARC_SIZE/2 + Math.cos(Math.toRadians(hColor))*87 ) -10+COLOR_ARC_X,
					(int)( COLOR_ARC_SIZE/2 - Math.sin(Math.toRadians(hColor))*87 ) -10+COLOR_ARC_Y, 20, 20);
		g.setColor(Color.BLACK);
		g.drawRect( (int)( COLOR_ARC_SIZE/2 + Math.cos(Math.toRadians(hColor))*87 ) -10+COLOR_ARC_X,
					(int)( COLOR_ARC_SIZE/2 - Math.sin(Math.toRadians(hColor))*87 ) -10+COLOR_ARC_Y, 20, 20);
	}
	
	/*
	 * ĕ`
	 */
	public void clear(){
		repaint();
	}
	
	/*
	 * [U[͂F
	 */
	public void getColorHue(int x,int y,boolean drag){
		double dx,dy,mag;
		
		setColorCode();
		
		// xNǧv
		dx = COLOR_ARC_SIZE/2-(double)(x);
		dy = COLOR_ARC_SIZE/2-(double)(y);
		mag = Math.pow(Math.abs( dx ),2) + Math.pow(Math.abs( dy ),2);
		// }EXJ[\̔
		if( mag > Math.pow(75,2) && mag < Math.pow(95,2) && !drag ){
			// NbN
			hColor = new Double( Math.toDegrees(Math.atan2(dy, -dx)) ).floatValue();
			drag_colorarc = true;
		} else if( drag && drag_colorarc ) {
			// hbO
			hColor = new Double( Math.toDegrees(Math.atan2(dy, -dx)) ).floatValue();
		} else {
			drag_colorarc = false;
		}
	}
	
	/*
	 * [U[͂ʓxƖx
	 */
	public void getColorSB(int x,int y,boolean drag){
		setColorCode();
		
		// }EXJ[\̔
		if( x>=50 && x<50+COLOR_RECT_SIZE && y>=50 && y<50+COLOR_RECT_SIZE && !drag ){
			// NbN
			sColor = 100-(y-50);
			bColor = x-50;
			drag_colorrect = true;
		} else if( drag && drag_colorrect ) {
			// hbO
			sColor = 100-(y-50);
			bColor = x-50;
			if(sColor<0) sColor = 0;
			if(sColor>100) sColor = 100;
			if(bColor<0) bColor = 0;
			if(bColor>100) bColor = 100;
		} else {
			drag_colorrect = false;
		}
	}
	
	/*
	 * [U[͂猻݂̐Fݒ
	 */
	public void setColorCode(){
		Color color;
		String str;
		color = Color.getHSBColor(hColor/COLOR_H_MAX, sColor/COLOR_S_MAX, bColor/COLOR_B_MAX);
		// RGB\L̐ݒ
		m_target.r_colorText.setText(
				Integer.toString(color.getRed()) );
		m_target.g_colorText.setText(
				Integer.toString(color.getGreen()) );
		m_target.b_colorText.setText(
				Integer.toString(color.getBlue()) );
		// F̐ݒ(񐔎rWA)
		m_target.colorCodeLabel.setBackground( color );
		// 16i\LJ[R[h̐ݒ
		str = "";
		if(color.getRed()<16) str += "0";
		str += Integer.toHexString(color.getRed());
		if(color.getGreen()<16) str += "0";
		str += Integer.toHexString(color.getGreen());
		if(color.getBlue()<16) str += "0";
		str += Integer.toHexString(color.getBlue());
		m_target.colorCodeText.setText(str);
	}
	
	public void mousePressed(MouseEvent e){
		getColorHue(e.getX()-COLOR_ARC_X,e.getY()-COLOR_ARC_Y,false);
		getColorSB(e.getX()-COLOR_ARC_X,e.getY()-COLOR_ARC_Y,false);
		repaint();
	}
	public void mouseReleased(MouseEvent e){
		
	}
	public void mouseEntered(MouseEvent e){
		
	}
	public void mouseExited(MouseEvent e){
		
	}
	public void mouseClicked(MouseEvent e){
		
	}
	public void mouseMoved(MouseEvent e){

	}
	public void mouseDragged(MouseEvent e){
		getColorHue(e.getX()-COLOR_ARC_X,e.getY()-COLOR_ARC_Y,true);
		getColorSB(e.getX()-COLOR_ARC_X,e.getY()-COLOR_ARC_Y,true);
		repaint();
	}
}
