package frame;
import java.awt.*;
import java.awt.event.*;

public class ColorSelectFrame extends Frame{

	/**
	 * 
	 */
	private static final long serialVersionUID = 3503496235929994054L;
	public Panel canvasPanel;
	public Panel colorPanel;

	public TextField r_colorText,g_colorText,b_colorText;
	public Label r_colorLabel,g_colorLabel,b_colorLabel;
	public TextField colorCodeText;
	public Label colorCodeLabel;
	
	// GUIiID`e[u
	public int[] gui_Table = {DUMMYLABEL,DUMMYLABEL,DUMMYLABEL,
	                          R_COLORLABEL,G_COLORLABEL,B_COLORLABEL,
	                          R_COLORTEXT,G_COLORTEXT,B_COLORTEXT,
	                          DUMMYLABEL,DUMMYLABEL,DUMMYLABEL,
	                          COLORCODETEXT,COLORCODELABEL,DUMMYLABEL,
	                          DUMMYLABEL,DUMMYLABEL,DUMMYLABEL };
	
	// GUIiID񋓌^萔
	private static final int DUMMYLABEL = 0;
	private static final int R_COLORTEXT = 1;
	private static final int G_COLORTEXT = 2;
	private static final int B_COLORTEXT = 3;
	private static final int R_COLORLABEL = 4;
	private static final int G_COLORLABEL = 5;
	private static final int B_COLORLABEL = 6;
	private static final int COLORCODETEXT = 7;
	private static final int COLORCODELABEL = 8;
	
	public ColorSelectFrame(String title){
		setTitle(title);
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
		
		// Cpl`
		setLayout(new GridLayout(1,2));
		canvasPanel = new Panel(new GridLayout(1,1));
		add(canvasPanel);
		
		// LoXpl`
		ColorSelectCanvas cvs = new ColorSelectCanvas(this);
		canvasPanel.add(cvs);
		
		setBackground(Color.LIGHT_GRAY);
		
		// GUIObhipl`
		colorPanel = new Panel(new GridLayout(6,3));
		add(colorPanel);
		for(int i=0;i<gui_Table.length;i++)
			setGuiTable(i,colorPanel);
		
		show();
	}
	
	/*
	 * e[uQGUIiݒ
	 */
	private void setGuiTable(int id,Panel panel){
		switch(gui_Table[id]){
			case DUMMYLABEL:
				createDummyLabel(panel);
				break;
			case R_COLORTEXT:
				r_colorText = new TextField(3);
				panel.add(r_colorText);
				break;
			case G_COLORTEXT:
				g_colorText = new TextField(3);
				panel.add(g_colorText);
				break;
			case B_COLORTEXT:
				b_colorText = new TextField(3);
				panel.add(b_colorText);
				break;
			case R_COLORLABEL:
				r_colorLabel = new Label("Red",Label.CENTER);
				r_colorLabel.setBackground(Color.LIGHT_GRAY);
				panel.add(r_colorLabel);
				break;
			case G_COLORLABEL:
				g_colorLabel = new Label("Green",Label.CENTER);
				g_colorLabel.setBackground(Color.LIGHT_GRAY);
				panel.add(g_colorLabel);
				break;
			case B_COLORLABEL:
				b_colorLabel = new Label("Blue",Label.CENTER);
				b_colorLabel.setBackground(Color.LIGHT_GRAY);
				panel.add(b_colorLabel);
				break;
			case COLORCODETEXT:
				colorCodeText = new TextField(6);
				colorPanel.add(colorCodeText);
				break;
			case COLORCODELABEL:
				colorCodeLabel = new Label("");
				colorCodeLabel.setBackground(Color.BLACK);
				colorPanel.add(colorCodeLabel);
				break;
		}
	}
	
	// GUI_~[iݒ
	private void createDummyLabel(Panel panel){
		Label label;
		label = new Label("");
		label.setBackground(Color.LIGHT_GRAY);
		panel.add(label);
	}
}
